;    
;   AT89C4051-24PI   58053

BAIT1		EQU	20H
BAIT2           EQU	21H	
RAZR1		EQU	30H
ZNA11		EQU	31H
ZNA12		EQU	32H
ZNA13		EQU	33H
RAZR2		EQU	34H
ZNA21		EQU	35H
ZNA22	        EQU     36H    ; 
ZNA23           EQU     37H    ; 
RAZR3 	        EQU     38H    ; 
ZNA31           EQU     39H    ; 
ZNA32		EQU	3AH
ZNA33           EQU     3BH  
 ; 
MEAN1	        EQU     3CH    ;    1
MEAN2		EQU	3DH    ;    2
MEAN3		EQU	3EH    ;    3
PER1		EQU	3FH
ZNAS1		EQU	40H
ZNAS2		EQU	41H
ZNRS1		EQU	42H
ZNRS2		EQU	43H
ZNRS3		EQU	44H
K15K1		EQU	45H
K15K2		EQU	46H
K15K3		EQU	47H
K15K4		EQU	48H

ZN1PW           BIT     20H.0
ZN2PW           BIT     20H.1
ZN3PW		BIT	20H.2
ZN4PW           BIT     20H.3
ZT1PW           BIT     20H.4
ZT2PW		BIT	20H.5
ZT3PW		BIT	20H.6
V2PW	        BIT	20H.7

DIR1	        BIT     21H.0
ENAB1           BIT     21H.1
DIR2		BIT	21H.2
ENAB2           BIT     21H.3
DIR3            BIT     21H.4
ENAB3		BIT	21H.5
TAYA1		BIT	21H.6
TAYA2	        BIT	21H.7

ZNAK2		BIT	28H.0
BUDS2           BIT     28H.1 
TIM2	    	BIT	28H.2
BUDK1           BIT     28H.3
BUDK2           BIT     28H.4
VREMS1		BIT	28H.5
ZNAK3		BIT	28H.6
KNOP5		BIT	28H.7

BUDS1           BIT     29H.0                       
ZNAK            BIT     29H.1
ZNAK1           BIT     29H.2
TIM1            BIT     29H.3
VREMS		BIT	29H.4
KNOP3		BIT	29H.5
KNOP4	 	BIT	29H.6

PUSK            BIT     2AH.0 
PUSK1           BIT     2AH.1 
SIG             BIT     2AH.2
FLAG            BIT     2AH.3
FLAG1           BIT     2AH.4
FLAG2           BIT     2AH.5
KNOP2           BIT     2AH.6
FLAG3		BIT	2AH.7 

FLAG4		BIT	2BH.0 
FLAG5		BIT	2BH.1 
FLAG6		BIT	2BH.2 
FLAG7		BIT	2BH.3 
STOP		BIT	2BH.4
REZ1		BIT	2BH.5
REZ2		BIT	2BH.6
REZ3		BIT	2BH.7

        JMP     INIT
        ORG     0BH
        JMP     OT
                                                
INIT:   CLR      A
	MOV	 BAIT1,#11111111B
	MOV	 BAIT2,#11111111B
        MOV      RAZR1,#1  
	MOV      RAZR2,#2 
	MOV      RAZR3,#3       
        MOV	 MEAN1,#42 	  ;   
	MOV	 MEAN2,#42 
	MOV	 MEAN3,#42 
 	MOV	 K15K1,#00000101B ;   1500 
	MOV	 K15K2,#11011100B
	MOV      R0,#RAZR1 
	MOV	 R1,#1
        MOV      R2,#00000001B         
        MOV	 R3,#100 
	MOV	 R4,#10 
	MOV	 R5,#100 
	MOV	 R6,#10 
        MOV      TMOD,#00000001B   
        MOV      TL0,#LOW(-3400)
        MOV      TH0,#HIGH(-3400)                                  
                                      
        CLR      PUSK             
        CLR      PUSK1                      
        CLR      FLAG             
        CLR      FLAG1            
        CLR      FLAG2
	CLR	 FLAG3
	CLR	 FLAG4                                          
        CLR      KNOP2
	CLR	 KNOP3 
	CLR	 KNOP4
	CLR	 TIM1
        CLR	 TIM2            
        CLR      BUDS1
        CLR	 BUDS2
        CLR      BUDK1
        CLR	 BUDK2
       
	SETB	 V2PW
           
        SETB     EA               
        SETB     ZNAK
	SETB	 ZNAK1             
	SETB	 VREMS
	SETB	 VREMS1
;	SETB	 BIP
;	SETB	 ZADF1
;	SETB	 P3.0
	SETB	 P3.1
	SETB	 P3.2
	SETB	 P3.3
	SETB	 P3.4
;	SETB	 P3.5
;	SETB	 P3.7
	SETB	 STOP
      	SETB	 ZT1PW  
	SETB	 ZT2PW  
	SETB	 ZT3PW  
	
	SETB	 P3.0		;
;	SETB	 P3.5
;	SETB	 P3.7
	SETB	TAYA1		; 58053
	SETB	TAYA2
	CLR	P3.1
	MOV	P1,BAIT2
	NOP
	SETB	P3.1

	MOV	 P1,#00010110B	;0- 
	CLR	 P3.0
	NOP
	SETB	 P3.0

	MOV	 P1,#01010110B	;1- 
	CLR	 P3.0
	NOP
	SETB	 P3.0

	MOV	 P1,#10010110B	;2- 
	CLR	 P3.0
	NOP
	SETB	 P3.0

	SETB     TR0              
        SETB     ET0  
                                                                           
SE1:  	                             
;     (    -)
	
	CLR	ET0
	MOV	ZNAS1,#0
	MOV	ZNRS1,#0
	MOV	ZNRS2,#0
	MOV	B,#16

	JB	REZ1,DOV1
	JB	REZ2,DOV2
	JB	REZ3,DOV3	
DOV1:	MOV	ZNAS2,MEAN1
	JMP	DOV6
DOV2:	MOV	ZNAS2,MEAN2
	JMP	DOV6
DOV3:	MOV	ZNAS2,MEAN3
		
DOV6:	MOV	K15K1,#00000000B
	MOV	K15K2,#00000000B
	MOV	K15K3,#00000101B
	MOV	K15K4,#11011100B
	CLR	C
DV1:	MOV	A,K15K4
	ADD	A,K15K4
	MOV	K15K4,A
	MOV	A,K15K3
	ADDC	A,K15K3
	MOV	K15K3,A
	MOV	A,K15K2
	ADDC	A,K15K2
	MOV	K15K2,A
	MOV	A,K15K1
	ADDC	A,K15K1
	MOV	K15K1,A
	JC	DV2

	MOV	A,K15K2
	SUBB	A,ZNAS2
	MOV	K15K2,A
	MOV	A,K15K1
	SUBB	A,ZNAS1
	MOV	K15K1,A
	JNC	DV3
	
	MOV	A,K15K2
	ADD	A,ZNAS2
	MOV	K15K2,A
	MOV	A,K15K1
	ADDC	A,ZNAS1
	MOV	K15K1,A
	JMP	DV4

DV2:	CLR	C
	MOV	A,K15K2
	SUBB	A,ZNAS2
	MOV	K15K2,A
	MOV	A,K15K1
	SUBB	A,ZNAS1
	MOV	K15K1,A
DV3:	INC	K15K4
DV4:	DJNZ	B,DV1
	CLR	C
	MOV	ZNAS1,K15K3
	MOV	ZNAS2,K15K4

SKL11:	MOV	B,#16		;(    -)
	JMP	SKL31

SKL21:	MOV	A,ZNRS2
	ADD	A,ZNRS2
	DA	A
	MOV	ZNRS2,A

	MOV	A,ZNRS1
	ADDC	A,ZNRS1
	DA	A
	MOV	ZNRS1,A

SKL31:	MOV	A,ZNAS2
	RLC	A
	MOV	ZNAS2,A
	MOV	A,ZNAS1
	RLC	A
	MOV	ZNAS1,A

	MOV	A,ZNRS2
	ADDC	A,#0
	MOV	ZNRS2,A
	DJNZ	B,SKL21

	JB	REZ1,DOVS1
	JB	REZ2,DOVS2
	JB	REZ3,DOVS3	
	
DOVS1:	MOV	ZNA11,ZNRS1
	MOV	A,ZNRS2
	SWAP	A
	ANL	A,#00001111B
	MOV	ZNA12,A
	ANL	ZNRS2,#00001111B
	MOV	ZNA13,ZNRS2
	JMP	DOVS4

DOVS2:	MOV	ZNA21,ZNRS1
	MOV	A,ZNRS2
	SWAP	A
	ANL	A,#00001111B
	MOV	ZNA22,A
	ANL	ZNRS2,#00001111B
	MOV	ZNA23,ZNRS2
	JMP	DOVS4

DOVS3:	MOV	ZNA31,ZNRS1
	MOV	A,ZNRS2
	SWAP	A
	ANL	A,#00001111B
	MOV	ZNA32,A
	ANL	ZNRS2,#00001111B
	MOV	ZNA33,ZNRS2	
DOVS4:	SETB	ET0
	JMP	SE1

KR580:  CLR	TAYA1		;     58053
	CLR	TAYA2
	MOV     A,R2
        JB      ACC.0,SOR11
        JB      ACC.1,SOR12
        JB      ACC.2,SOR13
SOR11:	MOV	PER1,MEAN1
	JMP	SILT
SOR12:	SETB	TAYA1
	MOV	PER1,MEAN2
	JMP	SILT
SOR13:	SETB	TAYA2
	MOV	PER1,MEAN3
SILT:	CLR	P3.1
	MOV	P1,BAIT2
	NOP
	SETB	P3.1
	
	MOV	P1,PER1		;
	CLR	P3.0		;
	NOP			;
	SETB	P3.0
	RET			;
                                        
OT:     CLR      TR0                     
        MOV      TL0,#LOW(-3400)         
        MOV      TH0,#HIGH(-3400)        
        SETB     TR0                     
        PUSH     ACC 
                      	
	DJNZ     R3,EMOK3
        MOV	 R3,#60
	JB       ZNAK,EMOK2  	
        CPL      FLAG
	
EMOK2:  JNB      PUSK,EMOK1             
	DJNZ     R4,EMOK3 
	MOV	 R4,#10                 
        CLR      ZNAK                    
        JMP	 EMOK3

EMOK1:  SETB	 ZNAK
EMOK3:  
	DJNZ     R5,EMOK31
        MOV	 R5,#60
	JB       ZNAK1,EMOK21  	
        CPL      FLAG1
	
EMOK21: JNB      PUSK1,EMOK11             
	DJNZ     R6,EMOK31 
	MOV	 R6,#10                 
        CLR      ZNAK1                    
        JMP	 EMOK31

EMOK11: SETB	 ZNAK1
EMOK31:	
	MOV	 P1,#11111110B		;  1( )
	NOP
        JB       P3.3,S1
        JB       FLAG,SAS5 ;(SA5)
        SETB     FLAG
	SETB	 PUSK
	MOV      A,R2
        JB       ACC.0,SOL11
        JB       ACC.1,SOL12
        JB       ACC.2,SOL13

SOL11:	MOV	 A,MEAN1
 	CJNE     A,#42,SAMK51 
	JMP	 SA5
SAMK51: INC	 MEAN1
	JMP      SAT5

SOL12:	MOV	 A,MEAN2
 	CJNE     A,#42,SAMK52 
	JMP	 SA5
SAMK52: INC	 MEAN2
	JMP      SAT5

SOL13:	MOV	 A,MEAN3
 	CJNE     A,#42,SAMK53 
	JMP	 SA5
SAMK53: INC	 MEAN3

SAT5:	CALL	 KR580
SAS5:   JMP	 SA5

S1:     CLR      FLAG
	CLR	 PUSK
        
SA1:   	MOV	 P1,#11111101B        ;  2( )
	NOP
        JB       P3.3,S2
        JB       FLAG1, SAS5 ;(SA5)
        SETB     FLAG1
	SETB 	 PUSK1
	MOV      A,R2
        JB       ACC.0,SOK11
        JB       ACC.1,SOK12
        JB       ACC.2,SOK13

SOK11:	MOV	 A,MEAN1
 	CJNE     A,#4,SAMK61
 	JMP	 SA5
SAMK61: DEC	 MEAN1
        JMP      SAT6

SOK12:	MOV	 A,MEAN2
 	CJNE     A,#4,SAMK62
 	JMP	 SA5
SAMK62: DEC	 MEAN2
        JMP      SAT6

SOK13:	MOV	 A,MEAN3
 	CJNE     A,#4,SAMK63
 	JMP	 SA5
SAMK63: DEC	 MEAN3
SAT6:	CALL	 KR580
	JMP      SA5
S2:     CLR      FLAG1
	CLR	 PUSK1
        
SA2:    MOV	 P1,#11111011B		;  3 (, )
        JB       P3.3,S3 
        JB       FLAG2,SAS5 ;(SA5)
        SETB     FLAG2
	MOV      A,R2
        JB       ACC.0,SOD1
        JB       ACC.1,SOD2
        JB       ACC.2,SOD3
SOD1:	CPL 	 DIR1
	CALL	 SILH
SOD2:	CPL	 DIR2
	CALL	 SILH
SOD3:	CPL	 DIR3
	CALL	 SILH

	JMP      SA5

SILH:	CLR	 P3.1			;  BAIT2   DD2
	MOV	 P1,BAIT2
	NOP
	SETB	 P3.1
	RET

S3:     CLR      FLAG2
			
SA3:	MOV	 P1,#11110111B		;  4 ( )
	NOP
        JB       P3.3,S4 
        JB       FLAG3,SA5
        SETB     FLAG3
        MOV      A,R2
        RL       A        
        MOV      R2,A
        JB       ACC.3,KN1 
        JMP      SA5
KN1:    MOV      R2,#00000001B
        MOV      R0,#RAZR1

	JMP	 SA5
S4:	CLR	 FLAG3 

SA4:	MOV	 P1,#11101111B		;  5 (/ 1)
	NOP
        JB       P3.3,S5 
        JB       FLAG4,SA5
        SETB     FLAG4
	CPL	 ENAB1
	CALL	 SILH
	JMP	 SA5
S5:	CLR	 FLAG4 

SA6:	MOV	 P1,#11011111B		;  6 (/ 2)
	NOP
        JB       P3.3,S6 
        JB       FLAG5,SA5
        SETB     FLAG5
	CPL	 ENAB2
	CALL	 SILH
	JMP	 SA5
S6:	CLR	 FLAG5 

SA7:	MOV	 P1,#10111111B		;  7 (/ 3)
	NOP
        JB       P3.4,S7 
        JB       FLAG6,SA5
        SETB     FLAG6
	CPL	 ENAB3
	CALL	 SILH
	JMP	 SA5
S7:	CLR	 FLAG6 

SA8:	MOV	 P1,#10111111B		;  8 ( - )
	NOP
        JB       P3.3,S8 
        JB       FLAG7,SA5
        SETB     FLAG7
	CLR	 ENAB1
	CLR	 ENAB2
	CLR	 ENAB3
	CALL	 SILH
	JMP	 SA5
S8:	CLR	 FLAG7 

SA5:	SETB	 ZT1PW
	SETB	 ZT2PW
	SETB	 ZT3PW
	JNB	 P3.4,SAL1
	CLR	 ZT1PW
SAL1:	JNB	 P3.5,SAL2
	CLR	 ZT2PW
SAL2:	JNB	 P3.7,SAL3
	CLR	 ZT3PW

SAL3:	SETB	 ZN1PW
	SETB	 ZN2PW
	SETB	 ZN3PW
	SETB	 ZN4PW
                              
FN0:    CJNE     R1,#1,FN1
	CLR	 ZN1PW 
        JMP	 FN11
FN1:	CJNE     R1,#2,FN2
	CLR	 ZN2PW         
        JMP	 FN11       
FN2:	CJNE     R1,#3,FN3
	CLR	 ZN3PW         
        JMP	 FN11
FN3:	CJNE     R1,#4,FN11
	CLR	 ZN4PW	
FN11:	MOV	 A,BAIT1

	CLR	 P3.2		;      DD5
	MOV	 P1,A
	NOP
	SETB	 P3.2

	CJNE     @R0,#0,FROS0   ;       
	MOV	 P1,#11000000B
	JMP	 FROS17
FROS0:	CJNE     @R0,#1,FROS1   
	MOV	 P1,#11111001B
	JMP	 FROS17
FROS1:	CJNE     @R0,#2,FROS2   
	MOV	 P1,#10100100B
	JMP	 FROS17
FROS2:	CJNE     @R0,#3,FROS3   
	MOV	 P1,#10110000B
	JMP	 FROS17
FROS3:	CJNE     @R0,#4,FROS4   
	MOV	 P1,#10011001B
	JMP	 FROS17
FROS4:	CJNE     @R0,#5,FROS5   
	MOV	 P1,#10010010B
	JMP	 FROS17
FROS5:	CJNE     @R0,#6,FROS6   
	MOV	 P1,#10000010B
	JMP	 FROS17
FROS6:	CJNE     @R0,#7,FROS7   
	MOV	 P1,#11111000B
	JMP	 FROS17
FROS7:	CJNE     @R0,#8,FROS8   
	MOV	 P1,#10000000B
	JMP	 FROS17
FROS8:	CJNE     @R0,#9,FROS9   
	MOV	 P1,#10010000B
	JMP	 FROS17
FROS9:	CJNE     @R0,#10,FROS10   
	MOV	 P1,#01110000B
	JMP	 FROS17
FROS10:	CJNE     @R0,#11,FROS11   
	MOV	 P1,#11001111B
	JMP	 FROS17
FROS11:	CJNE     @R0,#12,FROS13   
	MOV	 P1,#10100100B
	JMP	 FROS17
FROS13:	CJNE     @R0,#13,FROS14   
	MOV	 P1,#10000110B
	JMP	 FROS17
FROS14:	CJNE     @R0,#14,FROS15   
	MOV	 P1,#10001011B
	JMP	 FROS17
FROS15:	CJNE     @R0,#20,FROS17   
	MOV	 P1,#11111111B
		                         
FROS17: INC      R0
       	INC	 R1
        MOV      A,R2
        JB       ACC.0,TEMO0
        JB       ACC.1,TEMO1
        JB       ACC.2,TEMO2
      
TEMO0:  CJNE     R0,#34H,OUT
        MOV      R0,#RAZR1
	MOV	 R1,#1
	SETB	 REZ1
	CLR	 REZ2
	CLR	 REZ3      
        JMP      OUT

TEMO1:  CJNE     R0,#38H,OUT
        MOV      R0,#RAZR2
	MOV	 R1,#1
	SETB	 REZ2
	CLR	 REZ1
	CLR	 REZ3              
        JMP      OUT
         
TEMO2:  CJNE     R0,#3CH,OUT
        MOV      R0,#RAZR3
	MOV	 R1,#1
        SETB	 REZ3
	CLR	 REZ2
	CLR	 REZ1         
OUT:    POP     ACC                                                                               
        RETI
	END

